import java.util.Stack;
import java.util.StringTokenizer;
import java.io.IOException;

import javax.swing.UIManager;
import java.awt.*;
import java.io.*;
import java.awt.image.BufferedImage;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.Calendar;

public class Logo {
	static int qualite=0; // 0 normal // 1 vectoriel // 2 basse 
	static int largeur_dessin=1000;
	static int hauteur_dessin=1000;
	static int memoire=64; //Mmoire max relle attribue  la JVM
	static int tmp_memoire=64; // Correspond  la valuer dans l'onglet prfrences. Sera crit en fin d'application.
	static Stack flux=new Stack(); // Contient les flux de lecture ou d'criture
	static Stack chemin_flux=new Stack(); // Contient le chemin absolu vers chacun des fichiers
	static Stack description_flux=new Stack(); // Contient les identifiants de chacun des fluxs
	static Stack fin_flux=new Stack(); // Contient 1 si la fin du flux est atteinte rien sinon
  static String a_executer="# aucun";
  static String repertoire_defaut=System.getProperty("user.home");
  static int langage=0;  //entier reprsentant la langue choisie
  // 0 franais 1 anglais 2 gallois 3 espagnol 4 portugais 5 esperanto
  static int tortue_choisie=1; // Numro de la tortue qui dessine
  static int epaisseur_max=-1;  //epaisseur maximum autorise pour le crayon
  static boolean effacer_dessin = false; //effacer le dessin en quittant l'diteur
  static int tortues  = 16; // Nombre maximum de tortues
  static int forme_crayon = 0 ; // 0 pour carr 1 pour rond
  static Stack path=new Stack(); // Fichiers de dmarrage
  static int vitesse=0;		// Reprsente la vitesse de la tortue 0 rapide 100 lent
  static String version="0.9.21g";
  static int coloration_primitive=new Color(0,128,0).getRGB();
  static int style_primitive=Font.PLAIN;
  static int coloration_operande=Color.BLUE.getRGB();
  static int style_operande=Font.PLAIN;
  static int coloration_commentaire=Color.GRAY.getRGB();
  static int style_commentaire=Font.PLAIN;
  static int coloration_parenthese=Color.RED.getRGB();
  static int style_parenthese=Font.BOLD;
  static boolean COLOR_ENABLED=true;
  boolean packFrame = false;
  Cadre frame=null;
  static ResourceBundle messages=null;
	static long heure_demarrage; //heure a laquelle on a lance xlogo
	static Font police=new Font("dialog",Font.PLAIN,12); // Police de l'interface et de l'diteur

  /**Construire l'application*/
  public Logo() {
      // Lire le fichier de dmarrage
    	lis_config();
    	repertoire_defaut=rajoute_backslash(repertoire_defaut);
	if (null==messages)  genere_langue(langage); //Au cas o si le fichier de dmarrage ne contient rien sur la langue
   //Lancer le cadre
   frame = new Cadre();
    //Valider les cadres ayant des tailles prdfinies
    //Compacter les cadres ayant des infos de taille prfres - ex. depuis leur disposition
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    frame.setVisible(true);
    //On vrifie que la taille mmoire est suffisante pour crer l'image de dessin
	int memoire_necessaire=Logo.largeur_dessin*Logo.hauteur_dessin*4/1024/1024;
	long free=Runtime.getRuntime().freeMemory()/1024/1024;
	long total=Runtime.getRuntime().totalMemory()/1024/1024;
	if (total-free+memoire_necessaire>Logo.memoire*0.8){
		Logo.hauteur_dessin=1000;
		Logo.largeur_dessin=1000;
	}

    // On initialise le cadre principal
    init(frame);
    
    //  On gnre les primitives et les fichiers de dmarrages
    genere_primitive(); 
     
    //On lance le fichier  excuter au dmarrage s'il existe
    if (!Logo.a_executer.equals("# aucun")) {     
	      frame.affichage=new Affichage(frame,Cadre.decoupe(Logo.a_executer));
		   frame.affichage.start(); 
    }
    
    // On Enregistre le temps auquel la session a commenc
    heure_demarrage=Calendar.getInstance().getTimeInMillis();
  	}
  static void init(Cadre frame){
    // on centre la tortue
	Dimension d=frame.jScrollPane1.getViewport().getViewRect().getSize();
	Point p=new Point(Math.abs(largeur_dessin/2-d.width/2),Math.abs(hauteur_dessin/2-d.height/2));
	frame.jScrollPane1.getViewport().setViewPosition(p);  	

    // on affiche la tortue sur la zone de dessin

 // 	System.out.println("Total :"+Runtime.getRuntime().totalMemory()/1024+" max "+Runtime.getRuntime().maxMemory()/1024+" Free "+Runtime.getRuntime().freeMemory()/1024);
	
    frame.ardoise1.dessin=new BufferedImage(Logo.largeur_dessin,Logo.hauteur_dessin,BufferedImage.TYPE_INT_RGB);
 // 	System.out.println("Total :"+Runtime.getRuntime().totalMemory()/1024+" max "+Runtime.getRuntime().maxMemory()/1024+" Free "+Runtime.getRuntime().freeMemory()/1024);
      MediaTracker tracker=new MediaTracker(frame);
      tracker.addImage(frame.ardoise1.dessin,0);
      try{tracker.waitForID(0);}
      catch(InterruptedException e){}

      Graphics g=frame.ardoise1.dessin.getGraphics();
      g.setColor(Color.white);
      g.fillRect(0,0,Logo.largeur_dessin,Logo.hauteur_dessin);
      g.setColor(frame.couleurfond);
      if (null==frame.tortue.tort) {
        frame.tortue.coord();
        g.setXORMode(frame.tortue.couleurcrayon);
        g.drawPolygon(frame.tortue.triangle);
      }
      else {
        tracker=new MediaTracker(frame);
        tracker.addImage(frame.tortue.tort,0);
        try{tracker.waitForID(0);}
        catch(InterruptedException e){}
        g.setXORMode(frame.couleurfond);
        if (tracker.checkID(0))  g.drawImage(frame.tortue.tort, Logo.largeur_dessin/2 - frame.tortue.largeur / 2,
                    Logo.hauteur_dessin/2 - frame.tortue.hauteur/2, frame.ardoise1);
      }
      Graphics graph=frame.ardoise1.getGraphics();
      graph.drawImage(frame.ardoise1.dessin,0,0,frame);
  }
  void lis_config(){
	Locale locale=null;
	try{
	  String s="";
	  FileReader fr = new FileReader(System.getProperty("user.home")+File.separator+".xlogo");
	   while(fr.ready()){
		char[] b = new char[64];
		int i=fr.read(b);
		if (i==-1) break;
		s+=new String(b);
	  }
	  StringTokenizer st=new StringTokenizer(s,"\n");
	  while(st.hasMoreTokens()){
		String element=st.nextToken();
		if (element.equals("# langue")){
			element=st.nextToken();
		  	int id=Integer.parseInt(element);
		  	langage=id;
		  	genere_langue(id);
		}
		else if (element.equals("# vitesse")){
		  element=st.nextToken();
		  vitesse=Integer.parseInt(element);
		}
		else if (element.equals("# tortue choisie")) {
		  element=st.nextToken();
		  tortue_choisie=Integer.parseInt(element);
		}
		else if (element.equals("# nb max de tortues")){
			element=st.nextToken();
			Logo.tortues=Integer.parseInt(element);
		}
		else if(element.equals("# forme crayon")){
			element=st.nextToken();
			Logo.forme_crayon=Integer.parseInt(element);
		}
		else if(element.equals("# effacer dessin en quittant editeur")){
			int id=Integer.parseInt(st.nextToken());
			if (id==0) Logo.effacer_dessin=false;
			else Logo.effacer_dessin=true;
		}
		else if(element.equals("# epaisseur max crayon")){
			element=st.nextToken();
			Logo.epaisseur_max=Integer.parseInt(element);
		}
		else if(element.equals("# repertoire par defaut")) {
                  repertoire_defaut=st.nextToken();
                  File f=new File(repertoire_defaut);
                  if (!f.isDirectory()) repertoire_defaut=System.getProperty("user.home");
		}
		else if (element.equals("# a executer au demarrage")){
			element=st.nextToken();
			if (!element.equals("# aucun")) Logo.a_executer=element;
		}
		else if (element.equals("# police")){
			element=st.nextToken();
			String nom=element;
			element=st.nextToken();
			police=new Font(nom,Font.PLAIN,Integer.parseInt(element));
		}
		else if(element.equals("# hauteur")){
			Logo.hauteur_dessin=Integer.parseInt(st.nextToken());
		}
		else if(element.equals("# largeur")){
			Logo.largeur_dessin=Integer.parseInt(st.nextToken());
		}
		else if (element.equals("# memoire")){
			element=st.nextToken();
		  	memoire=Integer.parseInt(element);
		  	tmp_memoire=Integer.parseInt(element);
		}
		else if (element.equals("# qualite")){
			element=st.nextToken();
		  	qualite=Integer.parseInt(element);
		}
		else if (element.equals("# coloration")){
			element=st.nextToken();
			StringTokenizer sti=new StringTokenizer(element);
			if (sti.countTokens()==9){
				Logo.COLOR_ENABLED=(new Boolean(sti.nextToken())).booleanValue();
				Logo.coloration_commentaire=Integer.parseInt(sti.nextToken());	
				Logo.coloration_operande=Integer.parseInt(sti.nextToken());
				Logo.coloration_parenthese=Integer.parseInt(sti.nextToken());
				Logo.coloration_primitive=Integer.parseInt(sti.nextToken());
				Logo.style_commentaire=Integer.parseInt(sti.nextToken());
				Logo.style_operande=Integer.parseInt(sti.nextToken());
				Logo.style_parenthese=Integer.parseInt(sti.nextToken());
				Logo.style_primitive=Integer.parseInt(sti.nextToken());
			}
		}
		else if (element.equals("# fichiers de demarrage")) {
		  while (st.hasMoreTokens()){
			  element=st.nextToken();
//			  System.out.println(path+" "+element);
			if (!element.startsWith("#")) path.push(element);
		  }
		}
	  }
	}
	catch(Exception e){
	  System.out.println(e.toString());
	  Selection_Langue select=new Selection_Langue();
		while(!select.getSelection_faite()){
			try{
				Thread.currentThread().sleep(50);
			}
			catch(InterruptedException e1){}
		}
		select.dispose();
		try{
		FileWriter fw=new FileWriter(System.getProperty("user.home")+File.separator+".xlogo");
		BufferedWriter bf=new BufferedWriter(fw);
		bf.write("# langue\n0\n# vitesse\n0\n# tortue choisie\n1\n# nb max de tortues\n16\n# forme crayon\n0\n# effacer dessin en quittant editeur\n0\n# epaisseur max crayon\n-1\n# repertoire par defaut\n"+System.getProperty("user.home")+"\n hauteur\n1000\n# largeur\n1000\n# memoire\n64\n# a executer au demarrage\n# aucun\n# fichiers de demarrage\n# fin");
		bf.close();
		locale=genere_locale(langage);
		messages=ResourceBundle.getBundle("langage",locale);
	  }
	  catch(IOException ex){System.out.println("Ne peut crer le fichier de dmarrage!");}
	}
  }
  static void genere_langue(int id){ // fixe la langue utilise pour les messages
    Locale locale=null;
      locale=genere_locale(id);
      messages=ResourceBundle.getBundle("langage",locale);
  }
  static Locale genere_locale(int id){  //rend la locale correspondant  l'entier id
    Locale locale=null;
    switch(id){
      case 0: //franais
        locale=new Locale("fr","FR");
        break;
      case 1: //anglais
        locale=new Locale("en","US");
        break;
      case 2: //gallois
        locale=new Locale("cy","GB");
        break;
      case 3: //espagnol
      	locale=new Locale("es","SP");
      	break;
      case 4: // portugais
        locale=new Locale("pt","BR");
        break;
       case 5: //esperanto
       	locale=new Locale("eo","EO");
       	break;
    }
  return locale;
  }
  void genere_primitive(){
    frame.primitive=new Primitive(frame);
	if (Logo.qualite==1) {
	/*		frame.primitive.g.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS,RenderingHints.VALUE_FRACTIONALMETRICS_ON);
		frame.primitive.g.setRenderingHint(RenderingHints.KEY_INTERPOLATION,RenderingHints.VALUE_INTERPOLATION_BICUBIC);
		frame.primitive.g.setRenderingHint(RenderingHints.KEY_DITHERING,RenderingHints.VALUE_DITHER_ENABLE);
		frame.primitive.g.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING,RenderingHints.VALUE_COLOR_RENDER_QUALITY);
		frame.primitive.g.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION,RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);*/
		frame.primitive.g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
//		frame.primitive.g.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_QUALITY);
	//	frame.primitive.g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
		frame.primitive.g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.0f ));
	}
	else if (Logo.qualite==2){
		frame.primitive.g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF);
		frame.primitive.g.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_SPEED);
		frame.primitive.g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
	}

	
    frame.lanceprim=new LancePrimitive(frame);
    // Gnrer les procdures du path
    Stack tampon=new Stack();
	frame.editeur.affichable=true;
    int compteur=path.size();
    for (int i=0;i<compteur;i++){
      String txt="";
		if (path.get(i).equals("fini")) frame.editeur.affichable=false; //on passe aux fichiers de dmarrage
    else {
		try{
		//    System.out.println(path.get(i));
			RandomAccessFile f=new RandomAccessFile(path.get(i).toString(),"r");
			f.seek(0);
			txt+=f.readUTF();
			f.close();
		  	if (!frame.editeur.affichable) tampon.push(path.get(i).toString()); 
		  }
		  catch(FileNotFoundException e1){System.out.println("Fichier non trouv");}
		  catch(IOException e2){System.out.println("Problme de lecture du fichier");}
		  catch(Exception e3){}
		frame.editeur.zonedition.setText(txt);
		try {
		  frame.editeur.analyseprocedure();
		}
		catch(Exception e3){
		  System.out.println(e3.toString());
		}
		frame.editeur.setVisible(false);
	    }
    }
  path=(Stack)tampon.clone(); //On limine les fichiers du path qui ne sont pas des fichiers de dmarrage
  //  System.out.println(marqueur+"\n"+path);
    frame.editeur.affichable=true;
    frame.editeur.zonedition.setText("");

  }
  static String rajoute_backslash(String st){
	StringBuffer tampon=new StringBuffer();
	for(int j=0;j<st.length();j++){
		char c=st.charAt(j);
		if (c=='\\') tampon.append("\\\\");
		else if (c==' ') tampon.append("\\e");
		else if ("()[]#".indexOf(c)!=-1) tampon.append("\\"+c);
		else tampon.append(c);
	}
	return(new String(tampon));
  }
  /**Mthode principale*/
  public static void main(String[] args)   {
  	try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    String tampon="";
    //Rcuprer les fichiers de dmarrage correspondant  double clic de souris
    for(int i=0;i<args.length;i++){
    	if (i!=args.length-1) tampon+=args[i]+" ";
    	else tampon+=args[i];
    }
    StringTokenizer st=new StringTokenizer(tampon, "\u001B");
    while(st.hasMoreTokens()){
    	String element=st.nextToken();
    	path.push(element);
    }
    path.push("fini");
    new Logo();
  }
}